#!/usr/bin/perl -w

    ###################################################################
    #
    #	Copyright (c) Fazer
    #	cron_cleaner.pl
    #	Version: 7.5 (2019-10-02)
    #
    ###################################################################

    use strict;	# Возможно потребуется доустановить пакеты
    use DBI;	# yum install perl-DBI perl-DBD-MySQL perl-DB_File
		# or
		# apt-get install libdbi-perl libdbd-mysql-perl

#######################################################################
#	Конфигурация (множественные параметры - через пробел/запятую )
#
    # что бы реально удалять и переносить - поменять на: my $testmode = 'false';
    my $testmode = 'false'; 
    # my $testmode = 'false';

    # расширения файлов которые будут обрабатываться и удаляться при необходимости
    my $extension = "jpeg, jpg, gif, png, bmp";  

    # будет искать во всех ниже перечисленных полях всех таблиц в которых такие поля имеются
    my $fields = "photo photos image images img wm_image avatar content html cover_image logo picture";

    # папки которые сканируем "внутри" ./upload/, например: "000/u1 004 images";
    # если оставить пустым ($uploads = "";), будет сканироваться вся ./upload/ исключая ./upload/deleted/
    my $uploads = "000";

    # Список папок, исключенных из сканирования, ТОЛЬКО "ВЕРХНЕГО" уровня ./upload/NotDelete
    # например: "004, default" - не будет сканировать ./upload/004/ и ./upload/default/
    my $exceptions = "";

    # если установить в 'true' ненужные файлы будут удаляться безвозвратно а не переноситься в deleted
    my $delete = 'false';

    # расположение папки конфигурационных файлов CMS относительно самого скрипта
    my $conf = '../system/config/';

#######################################################################
#	Инициализация
#
    if (@ARGV){
        if ($ARGV[0] && $ARGV[0] == 1){$testmode = 'true';}
        if ($ARGV[1]){$extension = $ARGV[1];}
        if ($ARGV[2]){$fields = $ARGV[2];}
        if ($ARGV[3]){$uploads = $ARGV[3];}
        if ($ARGV[4]){$exceptions = $ARGV[4];}
        }
        unless ($extension){print " Nothing to do!,\n no valid extensions\n"; exit;}
        unless ($fields){print " Nothing to do!,\n no valid fields to SQL\n"; exit;}
        if ($testmode =~ /^false$/){print "TestMode = 'OFF'\n";} else {print "TestMode = 'ON'\n";}
            $uploads =~ s/^(.\/|\/)//g;

    use DB_File;
    use File::Basename;
    use File::Find qw(finddepth);
    use File::Path qw(make_path);
    use Cwd;

    my (%db_connect, %result, @result, $str);

    my $fullpath = dirname(__FILE__);
    chdir $fullpath or die $!;
    $fullpath = getcwd;
#    print "Am here $fullpath \n";

    open  (ERR,  ">$fullpath/cleaner_errors.txt");
    open  (LOGDIR,  ">$fullpath/cleaner_dirs.txt");
    open  (LOGFILE, ">$fullpath/cleaner_files.txt");
    open  (LOGLINKS, ">$fullpath/cleaner_select.txt");

    my @uploads = split (/ |\r|\n|,/,$uploads);
     unless (@uploads){
	 my @exceptions = split (/ |\r|\n|,/,$exceptions);
    	 my $exceptions = 'deleted';
	    if (@exceptions){
    	    foreach my $exc (@exceptions) {
	    $exc=~s/\s//g;
    	    if ($exc){$exceptions .= "|".$exc;}
	    }
        }
#    print "Exceptions - $exceptions\n";

	opendir(DIR, "./") or print (ERR "Cant open $fullpath $!\n");
	    my @dirs = grep { (!/^\./) && -d "./$_" } readdir(DIR);
            foreach my $dir (@dirs) {
	      unless ($dir =~ m/^($exceptions)$/i){
		push (@uploads ,$dir);
	      }
	    }
	closedir (DIR);
    }
#    print "Uploads - @uploads\n";

    my @extension = split (/ |\r|\n|,/,$extension);
     if (@extension){
     $extension = shift (@extension);
     if (@extension){
    	    foreach my $exp (@extension) {
	    $exp=~s/\s//g;
    	    if ($exp){$extension .= "|".$exp;}
	    }
        }
    } else {print " Nothing to do!,\n no valid extensions\n"; exit;}
#    print "Extensions - $extension\n";

    my @fields = split (/ |\r|\n|,/,$fields);
     if (@fields){
     $fields = "'".shift (@fields)."'";
        if (@fields){
    	    foreach my $fi (@fields) {
	    $fi=~s/\s//g;
    	    if ($fi){$fields .= ", '".$fi."'";}
	    }
        }
    } else {print " Nothing to do!,\n no valid fields\n"; exit;}
#    print "Fields - $fields\n";
#    print "ModeTest - $testmode\n";

    tie %result, 'DB_File', "$fullpath/result.db", O_RDWR|O_CREAT, 0660, $DB_BTREE or die "Can't tie $fullpath/result.db: $!";

#######################################################################
#
#	Обработка конфигурационных файлов 

    $conf =~ s/\/$//;

    open (CONF, "$conf/config.php") or die "Can't open $conf at $fullpath: $!";
    while (<CONF>){
    $str = $_;
    if ($str =~ m/.*'db_(.*)'.*=>.*'(.*)'/i){
    $db_connect{$1} = $2;
        }
    }
    close (CONF);

#    while(($str,)=(each %db_connect)){
#    print "$str = $db_connect{$str}\n";
#    } 

	# Обработка theme_*.yml файлов на наличие адресов картинок
	opendir(DIR, "$conf") or print (ERR "Cant open dir $conf at $fullpath $!\n");
	    my @files = readdir DIR;
	closedir (DIR);
            foreach my $fileyml (@files) {
		if ($fileyml=~/.*\.yml$/i) {
		    open (FILE, "$conf/$fileyml") or print (ERR "Cant open $conf/$fileyml $!\n");
#    print "$conf/$fileyml\n";
		    while (<FILE>){
			$str = $_;
    			my @str = split (/ |\r|\n/,$str);
			foreach $str (@str) {
    			    if ($str =~ m/(.*\/.*\.($extension)$)/i){
			        $result{$1} = undef;
#    print "$1 \n";
			    }
			}
		    }
		    close (FILE);
		}
	    }

#######################################################################
#
#	Запрос к базе, поиск всех нужных полей 

    my $db = DBI->connect("DBI:mysql:$db_connect{'base'}:$db_connect{'host'}", "$db_connect{'user'}", 
    "$db_connect{'pass'}", {mysql_auto_reconnect=>1})
       or die "Error connecting to database";

    my $request = "SELECT DISTINCT TABLE_NAME,COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS 
		    WHERE COLUMN_NAME IN ($fields) AND TABLE_SCHEMA='$db_connect{'base'}';";

    my $answer = $db->prepare($request);
       $answer->execute;
    while (my @row = $answer->fetchrow_array) {
	push @result, [ $row[0], $row[1] ];
	}
       $answer->finish;

###############################################################
#	Запрос к базе, создание хеша всех ссылок на изображения и файлы
#
        foreach my $tabfil (@result) {
    $request = "SELECT @$tabfil[1] FROM @$tabfil[0];";
#    print "$request \n";
    print (LOGLINKS "$request \n");
       $answer = $db->prepare($request);
       $answer->execute;
	    while (my @row = $answer->fetchrow_array) {
#    print "@row \n";
		foreach my $src (@row) {
		    if ($src){
    			my @src = split (/ |\r|\n/,$src);
    			    foreach $src (@src) {
	        		  if ($src =~ m/src=\"\/upload\/(.*)\"/i){
				      $result{$1} = undef;
#				      print "$1 \n";
				    } else {
    	        			if ($src =~ m/(.*\/.*\.($extension)$)/i){
				        $result{$1} = undef;
#				        print "$1 \n";
	    				}
				    }
			    }
		    }
		}
	    }
    	       $answer->finish;
	}

    $db->disconnect;

###############################################################
#  Рекурсивный проход по upload, сравнение с хешем ссылок, удаление(в т.ч. пустых папок) 
#

    my 	$ifiles = 0;
    my 	$idirs = 0;

  foreach my $upload (@uploads) {

	unless (opendir(DIR, $upload)){ print (ERR "Cant open ./upload/$upload/\n"); next;}
		closedir (DIR);

    finddepth \&recur, $upload;

    sub recur {
	if (-d) {
#	    print " dir $fullpath/$File::Find::name\n";
	opendir(DIR, "$fullpath/$File::Find::name") or print (ERR "Cant open $File::Find::name: $!\n");
	    my $dir = (grep !/^\.\.?$/, readdir DIR);
		closedir (DIR);
	    unless ($dir || (grep /^$File::Find::name$/, @uploads)){
     if ($testmode =~ /^false$/){
	rmdir ("$fullpath/$File::Find::name") or print (ERR "cannot rmdir $fullpath/$File::Find::name: $!\n");
		}
	$idirs++;
#    print "$File::Find::name \n";
		print (LOGDIR "$fullpath/$File::Find::name\n");
	    }
	} else {
	my $fil = $_;
        	if ($fil =~ m/.*\.($extension)$/i){
#		    print "file  $fil\n";
		    unless (exists $result{"$File::Find::name"}){
#		    print " rm -> $File::Find::name\n";
     if ($testmode =~ /^false$/){
			    if ($delete =~ /^true$/){
	    unlink ("$fullpath/$File::Find::name") or print (ERR "Can't delete $fullpath/$File::Find::name:  $!\n");
			    }else{
		    my $dir_name  = dirname "$File::Find::name";
		    unless (-d "$fullpath/deleted/$dir_name"){
		    make_path ("$fullpath/deleted/$dir_name") or print (ERR " Can't create $fullpath/deleted/$dir_name $!\n");
	    	    }
	    rename("$fullpath/$File::Find::name", "$fullpath/deleted/$File::Find::name") or print (ERR " Can't move $fullpath/deleted/$dir_name $fil $!\n");
			    }
			}
	$ifiles++;
    	    	print (LOGFILE "$fullpath/$File::Find::name\n");
		    } else {
#	    	print "    -> $File::Find::name\n";
		    }
    		}
	}
    }
  }
###############################################################
#	Закрытие
#

#    while(($str,)=(each %result)){
#    print "$str $result{$str}\n";
#    } 

    print (LOGFILE " $ifiles files for delete\n");
    print " $ifiles files for delete\n";
    print (LOGDIR " $idirs dirs for delete\n");
    print " $idirs dirs for delete\n";

    print "cron_cleaner ok \n";

untie %result;
unlink ("$fullpath/result.db") or die "Can't delete $fullpath/result.db:  $!\n";

close (ERR);
close (LOGDIR);
close (LOGFILE);
close (LOGLINKS);
